Subject: Re: [Cbor] Adam Roach's Block on charter-ietf-cbor-01-01: (with BLOCK)

From: "Alexey Melnikov" <[email-masked]>
Date: Tue, 02 Jul 2019 15:37:45 +0100

On Wed, Jun 26, 2019, at 6:53 AM, Carsten Bormann wrote:
> Hi Adam,
> 
> these are very good questions indeed.
> 
> As you may have noticed, the rescoping beyond IoT is not just happening 
> to CDDL.
> CBOR is now being used in a wide variety of specifications that have 
> varying aspects of IoTness to them, e.g., consider WebAuthn and CTAP2.  
> This is also visible in the set of people who are contributing.
> So I don’t think the rechartered CBOR WG as proposed will be an obscure 
> IoT only working group.

I agree that use of CBOR is not limited to IoT space. I struggle to make this any clearer in the charter text. Adam, do you think anything needs to change/ can be improved here?

> Of the three jobs of the rechartered WG, the CBORbis part has the 
> shortest timeline.
> Once that is finished, we are left with CDDL and the Tags documents 
> (and occasional media type documents).  While Tags are specific to 
> CBOR, they also could be viewed as a component model that will 
> increasingly be used in CDDL as well.  The more general purpose (or 
> internet-wide) Tags documents that would be worked on by the WG would 
> flow together with the desire to componentize CDDL.
> 
> With respect to the broader field of “schema languages”, the extreme 
> version of your proposal would be to merge into one WG the existing 
> netmod WG (the work on YANG), the CDDL work of the CBOR WG, and the 
> various approaches to data modeling being discussed on the JSON WG 
> mailing list right now.  Clearly, data modeling has become an important 
> aspect of the field of protocol development.  But that does not mean 
> all that work needs to be in one WG.  The constituents are overlapping, 
> but mostly distinct: operations and management, application layer and 
> security protocol design, application API development.
> 
> Creating a new “data modeling for JSON and friends” WG would send a 
> signal that we take the data modeling area more seriously.  But it 
> would also defocus from the evolution of CDDL as one description 
> technique in this space; it seems to me that the current approach of 
> evolving a number of coherent designs in a competitive manner is 
> ultimately more productive.
> 
> A pure CDDL working group would certainly work, but would leave the 
> work on Tags on the sidelines — keeping a CBOR working group just for 
> the Tags work (once CBORbis is completed) doesn’t seem to make a lot of 
> sense, and we want to achieve a higher degree of integration between 
> components work and language work anyway.

Considering size of the WG, people involved and the fact that CBOR model is more complex than JSON, so it is more likely to affect CDDL, I think it makes sense to keep both CBOR and any possible CDDL extensions in one place.

> So I think the charter proposal has it about right, with the possible 
> exception of the need for a signal that this WG is not just about IoT 
> any more.  But that signal can be outside the charter.

Agreed.

Best Regards,
Alexey

> Grüße, Carsten
> 
> 
> > On Jun 26, 2019, at 05:59, Adam Roach via Datatracker <[email-masked]> wrote:
> > 
> > Adam Roach has entered the following ballot position for
> > charter-ietf-cbor-01-01: Block
> > 
> > When responding, please keep the subject line intact and reply to all
> > email addresses included in the To and CC lines. (Feel free to cut this
> > introductory paragraph, however.)
> > 
> > 
> > 
> > The document, along with other ballot positions, can be found here:
> > https://datatracker.ietf.org/doc/charter-ietf-cbor/
> > 
> > 
> > 
> > ----------------------------------------------------------------------
> > BLOCK:
> > ----------------------------------------------------------------------
> > 
> > This is a "DISCUSS-discuss" style block, in the spirit of backing up and making
> > sure we're making the right overall decision here.
> > 
> > I'd like us to have a short conversation about whether it makes sense for the
> > CDDL work to continue in the CBOR working group. Given that it has been
> > rescoped and renamed to be a more general-purpose schema language covering not
> > just CBOR, but the much broader JSON universe, it seems that this work is
> > extremely likely to have a broad constituency outside of those people who
> > typically participate in working groups that focus on IoT use-cases. Keeping it
> > part of CBOR does not seem to serve that community well.
> > 
> > Should we consider splitting the CDDL update and maintenance work off into a
> > separate working group, rather than rechartering CBOR with the rather
> > significant expansion considered in this charter proposal?
> > 
> > 
> > 
> > 
> > _______________________________________________
> > CBOR mailing list
> > [email-masked]
> > https://www.ietf.org/mailman/listinfo/cbor
> > 
> 
>

---

From: Adam Roach <[email-masked]>
Date: Tue, 2 Jul 2019 12:16:48 -0400

Okay — I’m happy with the level of consideration that’s happened here. I merely wanted to ensure the possibility had been considered. I’ll clear.

/a

> On Jul 2, 2019, at 10:37, Alexey Melnikov <[email-masked]> wrote:
>